## falcosecurity-libs 0.18.1

=== driver/modern_bpf/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-only OR MIT
#
# Copyright (C) 2023 The Falco Authors.
#
# This file is dual licensed under either the MIT or GPL 2. See MIT.txt or GPL.txt for full copies
# of the license.
#

option(MODERN_BPF_DEBUG_MODE "Enable BPF debug prints" OFF)
option(MODERN_BPF_EXCLUDE_PROGS "Regex to exclude tail-called programs" "")

# ##################################################################################################
# Debug mode
# ##################################################################################################

if(MODERN_BPF_DEBUG_MODE)
	set(DEBUG "MODERN_BPF_DEBUG")
else()
	set(DEBUG "")
endif()
message(STATUS "${MODERN_BPF_LOG_PREFIX} MODERN_BPF_DEBUG_MODE: ${MODERN_BPF_DEBUG_MODE}")

# ##################################################################################################
# Check kernel version.
# ##################################################################################################

# We check it here because the skeleton could be provided with the `MODERN_BPF_SKEL_DIR` env
# variable so the compilation is still possible on older kernels.
execute_process(
	COMMAND uname -r
	OUTPUT_VARIABLE UNAME_RESULT
	OUTPUT_STRIP_TRAILING_WHITESPACE
)
string(REGEX MATCH "[0-9]+.[0-9]+" LINUX_KERNEL_VERSION ${UNAME_RESULT})
set(modern_bpf_min_kver_map_x86_64 5.8)
set(modern_bpf_min_kver_map_aarch64 5.8)
set(modern_bpf_min_kver_map_s390x 5.8)
set(modern_bpf_min_kver_map_ppc64le 5.8)
if(LINUX_KERNEL_VERSION VERSION_LESS ${modern_bpf_min_kver_map_${CMAKE_HOST_SYSTEM_PROCESSOR}})
	message(
		WARNING
			"${MODERN_BPF_LOG_PREFIX} To run this driver you need a Linux kernel version >= ${modern_bpf_min_kver_map_${CMAKE_HOST_SYSTEM_PROCESSOR}} but actual kernel version is: ${UNAME_RESULT}"
	)
endif()

# ##################################################################################################
# Get driver version.
# ##################################################################################################

# This is needed to obtain the modern bpf driver version
include(compute_versions RESULT_VARIABLE RESULT)
if(RESULT STREQUAL NOTFOUND)
	message(
		FATAL_ERROR
			"${MODERN_BPF_LOG_PREFIX} problem with compute_versions.cmake in ${CMAKE_MODULE_PATH}"
	)
endif()
compute_versions(../API_VERSION ../SCHEMA_VERSION)
configure_file(../driver_config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/../driver_config.h)

# ##################################################################################################
# Check clang version.
# ##################################################################################################

# If the user doesn't provide the path to `clang` try to find it locally
if(NOT MODERN_CLANG_EXE)
	find_program(
		MODERN_CLANG_EXE
		NAMES clang
		DOC "Path to clang executable"
	)
	if(NOT MODERN_CLANG_EXE)
		message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} unable to find clang")
	endif()
endif()

# If it is a relative path we convert it to an absolute one relative to the root source directory.
get_filename_component(
	MODERN_CLANG_EXE "${MODERN_CLANG_EXE}" ABSOLUTE BASE_DIR "${CMAKE_SOURCE_DIR}"
)
message(STATUS "${MODERN_BPF_LOG_PREFIX} clang used by the modern bpf probe: '${MODERN_CLANG_EXE}'")

# Check the right clang version (>=12)
execute_process(
	COMMAND ${MODERN_CLANG_EXE} --version
	OUTPUT_VARIABLE CLANG_version_output
	ERROR_VARIABLE CLANG_version_error
	RESULT_VARIABLE CLANG_version_result
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${CLANG_version_result} EQUAL 0)
	if("${CLANG_version_output}" MATCHES "clang version ([^\n]+)\n")
		# Transform X.Y.Z into X;Y;Z which can then be interpreted as a list
		set(CLANG_VERSION "${CMAKE_MATCH_1}")
		string(REPLACE "." ";" CLANG_VERSION_LIST ${CLANG_VERSION})
		list(GET CLANG_VERSION_LIST 0 CLANG_VERSION_MAJOR)

		string(COMPARE LESS ${CLANG_VERSION_MAJOR} 12 CLANG_VERSION_MAJOR_LT12)

		if(${CLANG_VERSION_MAJOR_LT12})
			message(
				WARNING
					"${MODERN_BPF_LOG_PREFIX} clang '${CLANG_VERSION}' is too old for compiling the modern BPF probe, you need at least '12.0.0' version"
			)
		endif()

		message(STATUS "${MODERN_BPF_LOG_PREFIX} Found clang version: ${CLANG_VERSION}")
	else()
		message(
			WARNING
				"${MODERN_BPF_LOG_PREFIX} Failed to parse clang version string: ${CLANG_version_output}"
		)
	endif()
else()
	message(
		FATAL_ERROR
			"${MODERN_BPF_LOG_PREFIX} Command \"${MODERN_CLANG_EXE} --version\" failed with output:\n ${CLANG_version_error}"
	)
endif()

# ##################################################################################################
# Check bpftool version.
# ##################################################################################################

# If the user doesn't provide the path to `bpftool` try to find it locally
if(NOT MODERN_BPFTOOL_EXE)
	find_program(
		MODERN_BPFTOOL_EXE
		NAMES bpftool
		DOC "Path to bpftool executable"
	)
	if(NOT MODERN_BPFTOOL_EXE)
		message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} unable to find bpftool on the system")
	endif()
endif()

# If it is a relative path we convert it to an absolute one relative to the root source directory.
get_filename_component(
	MODERN_BPFTOOL_EXE "${MODERN_BPFTOOL_EXE}" REALPATH BASE_DIR "${CMAKE_SOURCE_DIR}"
)
message(
	STATUS "${MODERN_BPF_LOG_PREFIX} bpftool used by the modern bpf probe: '${MODERN_BPFTOOL_EXE}'"
)

# Check the right bpftool version Since we want bpftool to have the gen skeleton subcommands and
# both gen and skeleton were added together, we can just grep the help output for gen. see:
# https://lore.kernel.org/bpf/20191210011438.4182911-12-andriin@fb.com/
#
# This is not as strict as checking versions, but it also allows compiling on bpftool versions for
# backported kernels.
execute_process(
	COMMAND sh -c "${MODERN_BPFTOOL_EXE} help 2>&1 | grep -wq 'gen'"
	OUTPUT_VARIABLE BPFTOOL_version_output
	ERROR_VARIABLE BPFTOOL_version_error
	RESULT_VARIABLE BPFTOOL_version_result
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT ${BPFTOOL_version_result} EQUAL 0)
	message(WARNING "${MODERN_BPF_LOG_PREFIX} bpftool does not support gen command")
endif()

# ##################################################################################################
# Get clang bpf system includes
# ##################################################################################################

execute_process(
	COMMAND bash -c "${MODERN_CLANG_EXE} -v -E - < /dev/null 2>&1 |
		  sed -n '/<...> search starts here:/,/End of search list./{ s| \\(/.*\\)|-idirafter \\1|p }'"
	OUTPUT_VARIABLE CLANG_SYSTEM_INCLUDES_output
	ERROR_VARIABLE CLANG_SYSTEM_INCLUDES_error
	RESULT_VARIABLE CLANG_SYSTEM_INCLUDES_result
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${CLANG_SYSTEM_INCLUDES_result} EQUAL 0)
	string(REPLACE "\n" " " CLANG_SYSTEM_INCLUDES "${CLANG_SYSTEM_INCLUDES_output}")
	message(STATUS "${MODERN_BPF_LOG_PREFIX} BPF system include flags: ${CLANG_SYSTEM_INCLUDES}")
else()
	message(
		FATAL_ERROR
			"${MODERN_BPF_LOG_PREFIX} Failed to determine BPF system includes: ${CLANG_SYSTEM_INCLUDES_error}"
	)
endif()

# ##################################################################################################
# Get target arch
# ##################################################################################################

execute_process(
	COMMAND uname -m
	COMMAND sed "s/x86_64/x86/"
	COMMAND sed "s/aarch64/arm64/"
	COMMAND sed "s/ppc64le/powerpc/"
	COMMAND sed "s/mips.*/mips/"
	COMMAND sed "s/s390x/s390/"
	OUTPUT_VARIABLE ARCH_output
	ERROR_VARIABLE ARCH_error
	RESULT_VARIABLE ARCH_result
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${ARCH_result} EQUAL 0)
	set(ARCH ${ARCH_output})
	message(STATUS "${MODERN_BPF_LOG_PREFIX} Target arch: ${ARCH}")
else()
	message(
		FATAL_ERROR
			"${MODERN_BPF_LOG_PREFIX} Failed to determine target architecture: ${ARCH_error}"
	)
endif()

# ##################################################################################################
# Set includes and compilation flags
# ##################################################################################################

# Get modern probe include.
list(APPEND MODERN_PROBE_INCLUDE "-I${CMAKE_CURRENT_SOURCE_DIR}")

# Note here we use the libs root directory since we want to avoid conflicts between the `bpf` folder
# inside `driver` and the `libbpf` includes.
set(PPM_INCLUDE ${LIBS_DIR})

# Set CLANG FLAGS
set(CLANG_FLAGS "")
list(
	APPEND
	CLANG_FLAGS
	-g
	-O2
	-target
	bpf
	-D__${DEBUG}__
	-D__TARGET_ARCH_${ARCH} # Match libbpf usage in `/libbpf/src/bpf_tracing.h`
	-D__USE_VMLINUX__ # Used to compile without kernel headers.
	-I${LIBBPF_INCLUDE}
	${MODERN_PROBE_INCLUDE}
	-I${PPM_INCLUDE}
	-isystem
)

message(STATUS "${MODERN_BPF_LOG_PREFIX} Compilation flags: ${CLANG_FLAGS}")

# Search all bpf includes files. (we can use bpf.h files)
file(GLOB_RECURSE BPF_H_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.h)

# Search all bpf.c files
file(GLOB_RECURSE BPF_C_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.bpf.c)

# ##################################################################################################
# Generate an `bpf.o` file for every `bpf.c`
# ##################################################################################################

foreach(BPF_C_FILE ${BPF_C_FILES})
	get_filename_component(file_stem ${BPF_C_FILE} NAME_WE)

	if(MODERN_BPF_EXCLUDE_PROGS)
		if(${file_stem} MATCHES "${MODERN_BPF_EXCLUDE_PROGS}")
			message(STATUS "Exclude file: ${file_stem}")
			continue()
		endif()
	endif()

	set(BPF_O_FILE ${CMAKE_CURRENT_BINARY_DIR}/${file_stem}.bpf.o)

	add_custom_command(
		OUTPUT ${BPF_O_FILE}
		COMMAND ${MODERN_CLANG_EXE} ${CLANG_FLAGS} ${CLANG_SYSTEM_INCLUDES} -c ${BPF_C_FILE} -o
				${BPF_O_FILE}
		VERBATIM
		DEPENDS libbpf
		DEPENDS ${BPF_C_FILE} ${BPF_H_FILES}
		COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF object: ${BPF_O_FILE}"
	)

	list(APPEND BPF_OBJECT_FILES ${BPF_O_FILE})
endforeach()

# ##################################################################################################
# Generate a unique `bpf.o` file
# ##################################################################################################

set(UNIQUE_BPF_O_FILE ${CMAKE_CURRENT_BINARY_DIR}/${UNIQUE_BPF_O_FILE_NAME}.o)
add_custom_command(
	OUTPUT ${UNIQUE_BPF_O_FILE}
	COMMAND ${MODERN_BPFTOOL_EXE} gen object ${UNIQUE_BPF_O_FILE} ${BPF_OBJECT_FILES}
	VERBATIM
	DEPENDS ${BPF_OBJECT_FILES}
	COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF unique object file: ${UNIQUE_BPF_O_FILE}"
)

# ##################################################################################################
# Generate the skeleton file
# ##################################################################################################

set(BPF_SKEL_FILE ${MODERN_BPF_SKEL_DIR}/${UNIQUE_BPF_O_FILE_NAME}.skel.h)
add_custom_command(
	OUTPUT ${BPF_SKEL_FILE}
	COMMAND bash -c "${MODERN_BPFTOOL_EXE} gen skeleton ${UNIQUE_BPF_O_FILE} > ${BPF_SKEL_FILE}"
	VERBATIM
	DEPENDS ${UNIQUE_BPF_O_FILE}
	COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF skeleton: ${BPF_SKEL_FILE}"
)

# ##################################################################################################
# Add the skeleton as a custom target
# ##################################################################################################

add_custom_target(ProbeSkeleton ALL DEPENDS ${BPF_SKEL_FILE})

=== test/libscap/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

message(STATUS "Libscap unit tests build enabled")

if(NOT DEFINED DRIVER_NAME)
	set(DRIVER_NAME "scap")
endif()

# Create a libscap_test_var.h file with some variables used by our tests for example the kmod path
# or the bpf path.
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/libscap_test_var.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/libscap_test_var.h"
)

set(LIBSCAP_TESTS_INCLUDE
	PRIVATE
	"${GTEST_INCLUDE}"
	"${CMAKE_CURRENT_SOURCE_DIR}" # for test helpers <helpers/...>
	"${LIBS_DIR}"
	"${LIBS_DIR}/userspace"
	"${PROJECT_BINARY_DIR}"
	"${CMAKE_CURRENT_BINARY_DIR}" # used to include `libscap_test_var.h`
)

# Needed by gtest
find_package(Threads)

set(LIBSCAP_TESTS_LIBRARIES "${GTEST_LIB}" "${GTEST_MAIN_LIB}" "${CMAKE_THREAD_LIBS_INIT}" scap)

set(LIBSCAP_TESTS_DEPENDENCIES gtest scap)

# Test suite asserting against pure userspace components
file(GLOB_RECURSE USERSPACE_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/userspace/*.cpp")
set(LIBSCAP_TESTS_SOURCES ${USERSPACE_TEST_SUITE})

# Helpers are not engine-specific so we always include them
file(GLOB_RECURSE LIBSCAP_TESTS_UTILS_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/helpers/*cpp")
list(APPEND LIBSCAP_TESTS_SOURCES ${LIBSCAP_TESTS_UTILS_SOURCES})

# Linux specific tests
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	file(GLOB_RECURSE LINUX_TEST_SUITE
		 "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/userspace/linux/*.cpp"
	)
	list(APPEND LIBSCAP_TEST_SOURCES ${LINUX_TEST_SUITE})
	list(APPEND LIBSCAP_TESTS_LIBRARIES scap_engine_util)
endif()

# Engine-specific tests
if(BUILD_DRIVER)
	file(GLOB_RECURSE KMOD_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/kmod/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${KMOD_TEST_SUITE})
	# Set `driver` target as a dependency
	list(APPEND LIBSCAP_TESTS_DEPENDENCIES driver)
endif()

if(BUILD_BPF)
	file(GLOB_RECURSE BPF_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/bpf/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${BPF_TEST_SUITE})
	# Set `bpf` target as a dependency
	list(APPEND LIBSCAP_TESTS_DEPENDENCIES bpf)
endif()

if(BUILD_LIBSCAP_MODERN_BPF)
	file(GLOB_RECURSE MODERN_BPF_TEST_SUITE
		 "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/modern_bpf/*.cpp"
	)
	list(APPEND LIBSCAP_TESTS_SOURCES ${MODERN_BPF_TEST_SUITE})
endif()

if(BUILD_LIBSCAP_GVISOR)
	include(protobuf)
	file(GLOB_RECURSE GVISOR_TEST_SUITE
		 "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/gvisor/*.cpp"
	)
	list(APPEND LIBSCAP_TESTS_SOURCES ${GVISOR_TEST_SUITE})
	list(APPEND LIBSCAP_TESTS_INCLUDE "${CMAKE_BINARY_DIR}/libscap/engine/gvisor"
	)# Used for <pkg/sentry/...> includes
endif()

# Summary logs
set(LIBSCAP_UNIT_TESTS_PREFIX "[LIBSCAP UNIT TESTS]")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_SOURCES: ${LIBSCAP_TESTS_SOURCES}")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_INCLUDE: ${LIBSCAP_TESTS_INCLUDE}")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_LIBRARIES: ${LIBSCAP_TESTS_LIBRARIES}")
message(
	STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_DEPENDENCIES: ${LIBSCAP_TESTS_DEPENDENCIES}"
)

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})
add_executable(libscap_test ${LIBSCAP_TESTS_SOURCES})
target_include_directories(libscap_test ${LIBSCAP_TESTS_INCLUDE})
target_link_libraries(libscap_test ${LIBSCAP_TESTS_LIBRARIES})
add_dependencies(libscap_test ${LIBSCAP_TESTS_DEPENDENCIES})

=== test/libsinsp_e2e/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2024 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

message(STATUS "Libsinsp unit e2e tests build enabled")

if(NOT DEFINED DRIVER_NAME)
	set(DRIVER_NAME "scap")
endif()

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

# Create a libsinsp_test_var.h file with some variables used by our tests for example the kmod path
# or the bpf path.
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/libsinsp_test_var.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/libsinsp_test_var.h"
)

add_executable(
	libsinsp_e2e_tests
	capture_to_file_test.cpp
	container/container.cpp
	container/container_cgroup.cpp
	container/docker_utils.cpp
	event_capture.cpp
	forking.cpp
	fs.cpp
	ipv6.cpp
	main.cpp
	paths.cpp
	process.cpp
	subprocess.cpp
	suppress_events.cpp
	sys_call_test.cpp
	tcp_client_server.cpp
	tcp_client_server_ipv4_mapped.cpp
	threadinfo.cpp
	thread_state.cpp
	udp_client_server.cpp
	unix_client_server.cpp
)

if(BUILD_BPF)
	add_dependencies(libsinsp_e2e_tests driver bpf)
else()
	add_dependencies(libsinsp_e2e_tests driver)
endif()

target_link_libraries(libsinsp_e2e_tests sinsp GTest::gtest pthread)

target_include_directories(
	libsinsp_e2e_tests PRIVATE ${PROJECT_BINARY_DIR}/driver/src "${CMAKE_CURRENT_BINARY_DIR}"
)

add_executable(test_helper test_helper.cpp)
target_link_libraries(test_helper pthread)
add_dependencies(libsinsp_e2e_tests test_helper)

add_executable(vtidcollision vtidcollision.c)
add_dependencies(libsinsp_e2e_tests vtidcollision)

execute_process(
	COMMAND "uname" "-m"
	OUTPUT_VARIABLE ARCH
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
	# Build 32-bit tests only for architectures where that is supported
	if(${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "x86_64")
		add_executable(test_helper_32 test_helper.cpp)
		set_target_properties(test_helper_32 PROPERTIES COMPILE_FLAGS "-m32" LINK_FLAGS "-m32")
		target_link_libraries(test_helper_32 pthread)
		add_dependencies(libsinsp_e2e_tests test_helper_32)
	endif()
endif("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")

configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/test_helper.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test_helper.sh
)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/resources/ DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/resources/)

execute_process(
	COMMAND tar xzf ${CMAKE_CURRENT_BINARY_DIR}/resources/fake-proc.tar.gz
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/resources/
)

=== userspace/libpman/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

add_library(
	pman
	src/stats.c
	src/maps.c
	src/lifecycle.c
	src/programs.c
	src/ringbuffer.c
	src/configuration.c
	src/state.c
	src/sc_set.c
)

target_include_directories(
	pman
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
	PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
			$<BUILD_INTERFACE:${LIBS_DIR}> # ppm_enum and tables
			$<BUILD_INTERFACE:${LIBS_DIR}/userspace> # scap-stats struct
			${ZLIB_INCLUDE}
			${LIBBPF_INCLUDE}
			${MODERN_BPF_SKEL_DIR}
			${LIBELF_INCLUDE}
)

target_link_libraries(
	pman PUBLIC scap_event_schema scap_platform ${LIBBPF_LIB} ${LIBELF_LIB} ${ZLIB_LIB}
)

if(TARGET ProbeSkeleton)
	add_dependencies(pman ProbeSkeleton)
endif()

if(USE_BUNDLED_LIBBPF)
	add_dependencies(pman libbpf)
endif()

=== userspace/libscap/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

include(engine_config)

option(USE_BUNDLED_DEPS "Enable bundled dependencies instead of using the system ones" ON)

include(ExternalProject)

include(zlib)

add_definitions(-DPLATFORM_NAME="${CMAKE_SYSTEM_NAME}")
add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	if(CMAKE_BUILD_TYPE STREQUAL "Debug")
		set(KBUILD_FLAGS "${FALCOSECURITY_LIBS_DEBUG_FLAGS}")
	endif()

	# do not remove this since when WITH_DRIVER is off
	if(NOT DEFINED DRIVER_NAME)
		set(DRIVER_NAME "scap")
	endif()

	string(REPLACE "-" "_" SCAP_KERNEL_MODULE_NAME "${DRIVER_NAME}")
	add_definitions(-DSCAP_KERNEL_MODULE_NAME="${SCAP_KERNEL_MODULE_NAME}")
endif()

if(NOT DEFINED SCAP_HOST_ROOT_ENV_VAR_NAME)
	set(SCAP_HOST_ROOT_ENV_VAR_NAME "HOST_ROOT")
endif()
add_definitions(-DSCAP_HOST_ROOT_ENV_VAR_NAME="${SCAP_HOST_ROOT_ENV_VAR_NAME}")

if(NOT DEFINED SCAP_HOSTNAME_ENV_VAR)
	set(SCAP_HOSTNAME_ENV_VAR "SCAP_HOSTNAME")
endif()
add_definitions(-DSCAP_HOSTNAME_ENV_VAR="${SCAP_HOSTNAME_ENV_VAR}")

if(DEFINED SCAP_BPF_PROGS_TAIL_CALLED_MAX)
	add_definitions(-DBPF_PROGS_TAIL_CALLED_MAX=${SCAP_BPF_PROGS_TAIL_CALLED_MAX})
endif()

configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/scap_strl_config.h.in
	${CMAKE_CURRENT_BINARY_DIR}/scap_strl_config.h
)
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/scap_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/scap_config.h
)

add_library(scap_error STATIC strerror.c)

target_include_directories(scap_error PUBLIC $<BUILD_INTERFACE:${LIBS_DIR}/userspace>)

add_library(scap scap.c scap_api_version.c scap_savefile.c scap_platform_api.c)

target_include_directories(
	scap
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
		   $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
		   $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include/${LIBS_PACKAGE_NAME}>
)

set_scap_target_properties(scap)

add_library(
	scap_platform_util STATIC scap_platform.c scap_fds.c scap_iflist.c scap_proc_util.c
							  scap_procs.c scap_userlist.c
)
add_dependencies(scap_platform_util uthash)

target_include_directories(
	scap_platform_util
	PUBLIC $<BUILD_INTERFACE:${LIBS_DIR}> $<BUILD_INTERFACE:${LIBS_DIR}/userspace>
		   $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
)

target_link_libraries(scap PRIVATE scap_error "${ZLIB_LIB}")

add_library(
	scap_event_schema STATIC
	scap_event.c
	ppm_sc_names.c
	${LIBS_DIR}/driver/dynamic_params_table.c
	${LIBS_DIR}/driver/event_table.c
	${LIBS_DIR}/driver/flags_table.c
	${LIBS_DIR}/driver/syscall_table64.c
	${LIBS_DIR}/driver/syscall_ia32_64_map.c
	linux/scap_ppm_sc.c
)

add_dependencies(scap_event_schema uthash)

target_include_directories(
	scap_event_schema
	PUBLIC $<BUILD_INTERFACE:${LIBS_DIR}> $<BUILD_INTERFACE:${LIBS_DIR}/userspace>
		   $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
)

target_link_libraries(scap PUBLIC scap_event_schema)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	option(BUILD_LIBSCAP_EXAMPLES "Build libscap examples" ON)
	include(FindMakedev)

	add_subdirectory(linux)
	target_link_libraries(scap PUBLIC scap_platform)

	add_library(driver_event_schema STATIC ${LIBS_DIR}/driver/fillers_table.c)

	target_link_libraries(scap_event_schema driver_event_schema)

	add_library(
		scap_engine_util STATIC scap_engine_util.c ringbuffer/devset.c ringbuffer/ringbuffer.c
								ringbuffer/ringbuffer_dump.c
	)
	add_dependencies(scap_engine_util uthash)
	target_include_directories(
		scap_engine_util
		PUBLIC $<BUILD_INTERFACE:${LIBS_DIR}> $<BUILD_INTERFACE:${LIBS_DIR}/userspace>
			   $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
	)
	target_link_libraries(scap PRIVATE scap_engine_util)
endif()

# ################# LISCAP ENGINES ##################

add_subdirectory(engine/noop)
# don't link the noop engine to libscap directly, it's a helper library for other engines (it's
# completely useless on its own)

if(HAS_ENGINE_NODRIVER)
	add_subdirectory(engine/nodriver)
	target_link_libraries(scap PUBLIC scap_engine_nodriver)
endif()

if(HAS_ENGINE_TEST_INPUT)
	# Add engine only used for testing
	add_subdirectory(engine/test_input)
	target_link_libraries(scap PUBLIC scap_engine_test_input)
endif()

if(HAS_ENGINE_SAVEFILE)
	add_subdirectory(engine/savefile)
	target_link_libraries(scap PUBLIC scap_engine_savefile)
endif()

if(HAS_ENGINE_SOURCE_PLUGIN)
	add_subdirectory(engine/source_plugin)
	target_link_libraries(scap PUBLIC scap_engine_source_plugin)
endif()

if(HAS_ENGINE_KMOD)
	add_subdirectory(engine/kmod)
	target_link_libraries(scap PUBLIC scap_engine_kmod)
	target_include_directories(scap_engine_kmod PRIVATE ${PROJECT_BINARY_DIR}/driver/src)
endif()

if(HAS_ENGINE_BPF)
	include(libelf)
	add_subdirectory(engine/bpf)
	target_link_libraries(scap PUBLIC scap_engine_bpf)
	target_include_directories(scap_engine_bpf PRIVATE ${PROJECT_BINARY_DIR}/driver/src)
endif()

if(HAS_ENGINE_MODERN_BPF)
	include(libelf)
	add_subdirectory(engine/modern_bpf)
	target_link_libraries(scap PUBLIC scap_engine_modern_bpf)
	target_include_directories(scap_engine_modern_bpf PRIVATE ${PROJECT_BINARY_DIR}/driver/src)
endif()

if(HAS_ENGINE_GVISOR)
	add_subdirectory(engine/gvisor)
	# The static and shared build differs here because a shared scap_engine_gvisor will result in
	# circular dependencies.
	if(BUILD_SHARED_LIBS)
		# We can move this to the gvisor CMakeFile when we use CMake 3.13 or later.
		# https://cmake.org/cmake/help/latest/policy/CMP0079.html
		target_link_libraries(scap PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${PROTOBUF_LIB} ${JSONCPP_LIB})
	else()
		target_link_libraries(scap PRIVATE scap_engine_gvisor)
	endif()
endif()

# ##################################################################################################

if(BUILD_LIBSCAP_EXAMPLES)
	add_subdirectory(examples/01-open)
	add_subdirectory(examples/02-validatebuffer)
endif()

=== userspace/libsinsp/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

option(USE_BUNDLED_DEPS "Enable bundled dependencies instead of using the system ones" ON)
option(ENABLE_THREAD_POOL "Enable inspector thread pool" OFF)

if(NOT MSVC)
	add_definitions(-DHAVE_PWD_H)
	add_definitions(-DHAVE_GRP_H)
	if(MUSL_OPTIMIZED_BUILD)
		add_definitions(-DMUSL_OPTIMIZED)
	endif()

	add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
	add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})
endif()

include(ExternalProject)

include(jsoncpp)
include(zlib)

if(NOT MINIMAL_BUILD)
	if(NOT WIN32 AND NOT EMSCRIPTEN)
		include(curl)
		include(cares)
	endif() # NOT WIN32
endif()

if(NOT WIN32 AND NOT APPLE)
	if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
		include(grpc)
		include(protobuf)
		include(openssl)
	endif() # NOT MINIMAL_BUILD
endif()

if(NOT EMSCRIPTEN)
	include(tbb)
endif()

add_library(
	sinsp
	filter/ast.cpp
	filter/escaping.cpp
	filter/parser.cpp
	filter/ppm_codes.cpp
	container.cpp
	container_engine/container_engine_base.cpp
	container_engine/static_container.cpp
	container_info.cpp
	sinsp_cycledumper.cpp
	event.cpp
	eventformatter.cpp
	dns_manager.cpp
	dumper.cpp
	fdinfo.cpp
	filter.cpp
	sinsp_filter_transformer.cpp
	sinsp_filtercheck.cpp
	sinsp_filtercheck_container.cpp
	sinsp_filtercheck_event.cpp
	sinsp_filtercheck_evtin.cpp
	sinsp_filtercheck_fd.cpp
	sinsp_filtercheck_fdlist.cpp
	sinsp_filtercheck_fspath.cpp
	sinsp_filtercheck_gen_event.cpp
	sinsp_filtercheck_group.cpp
	sinsp_filtercheck_k8s.cpp
	sinsp_filtercheck_mesos.cpp
	sinsp_filtercheck_rawstring.cpp
	sinsp_filtercheck_reference.cpp
	sinsp_filtercheck_syslog.cpp
	sinsp_filtercheck_thread.cpp
	sinsp_filtercheck_tracer.cpp
	sinsp_filtercheck_user.cpp
	sinsp_filtercheck_utils.cpp
	filter_compare.cpp
	filter_check_list.cpp
	ifinfo.cpp
	metrics_collector.cpp
	logger.cpp
	parsers.cpp
	${LIBS_DIR}/userspace/plugin/plugin_loader.c
	plugin.cpp
	plugin_table_api.cpp
	plugin_filtercheck.cpp
	prefix_search.cpp
	sinsp_syslog.cpp
	threadinfo.cpp
	tuples.cpp
	sinsp.cpp
	token_bucket.cpp
	utils.cpp
	value_parser.cpp
	user.cpp
	gvisor_config.cpp
	sinsp_suppress.cpp
	events/sinsp_events.cpp
	events/sinsp_events_ppm_sc.cpp
)

if(ENABLE_THREAD_POOL AND NOT EMSCRIPTEN)
	target_sources(sinsp PRIVATE sinsp_thread_pool_bs.cpp)
endif()

if(NOT WIN32 AND NOT APPLE)
	target_sources(sinsp PRIVATE procfs_utils.cpp sinsp_cgroup.cpp)
endif()

if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
	target_sources(
		sinsp PRIVATE container_engine/docker/async_source.cpp container_engine/docker/base.cpp
	)
	if(NOT WIN32)
		target_sources(
			sinsp
			PRIVATE container_engine/docker/docker_linux.cpp
					container_engine/docker/connection_linux.cpp
					container_engine/docker/podman.cpp
					container_engine/libvirt_lxc.cpp
					container_engine/lxc.cpp
					container_engine/mesos.cpp
					container_engine/rkt.cpp
					container_engine/bpm.cpp
					cri_settings.cpp
					runc.cpp
		)
	endif()

	if(NOT WIN32 AND NOT APPLE)
		target_sources(
			sinsp PRIVATE cgroup_limits.cpp container_engine/cri.cpp grpc_channel_registry.cpp
		)
	endif()
endif()

target_include_directories(
	sinsp
	PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> $<BUILD_INTERFACE:${LIBS_DIR}/userspace>
		   $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include/${LIBS_PACKAGE_NAME}>
)

if(EMSCRIPTEN)
	target_compile_options(sinsp PRIVATE "-sDISABLE_EXCEPTION_CATCHING=0")
endif()

set_sinsp_target_properties(sinsp)

target_link_libraries(
	sinsp
	PUBLIC scap
	PRIVATE "${CURL_LIBRARIES}" "${JSONCPP_LIB}" "${RE2_LIB}"
)

set(SINSP_PKGCONFIG_LIBRARIES scap "${ZLIB_LIB}" "${CURL_LIBRARIES}" "${JSONCPP_LIB}" "${RE2_LIB}")

if(NOT EMSCRIPTEN)
	target_link_libraries(
		sinsp
		INTERFACE "${CARES_LIB}"
		PRIVATE "${TBB_LIB}"
	)
	list(APPEND SINSP_PKGCONFIG_LIBRARIES "${CARES_LIB}")
endif()

if(USE_BUNDLED_VALIJSON)
	add_dependencies(sinsp valijson)
endif()

if(USE_BUNDLED_RE2)
	add_dependencies(sinsp re2)
endif()

if(USE_BUNDLED_JSONCPP)
	add_dependencies(sinsp jsoncpp)
endif()

if(ENABLE_THREAD_POOL AND USE_BUNDLED_BS_THREADPOOL)
	add_dependencies(sinsp bs_threadpool)
endif()

function(prepare_cri_grpc api_version)
	configure_file(
		${CMAKE_CURRENT_SOURCE_DIR}/cri-${api_version}.proto
		${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto COPYONLY
	)
	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.cc
			   ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.h
			   ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.cc
			   ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.h
		COMMENT "Generate CRI grpc code for API version ${api_version}"
		DEPENDS
		COMMAND ${PROTOC} -I ${CMAKE_CURRENT_BINARY_DIR} --cpp_out=.
				${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto
		COMMAND
			${PROTOC} -I ${CMAKE_CURRENT_BINARY_DIR} --grpc_out=.
			--plugin=protoc-gen-grpc=${GRPC_CPP_PLUGIN}
			${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	)
	add_library(
		cri_${api_version} STATIC ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.cc
								  ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.cc
	)
	target_include_directories(
		cri_${api_version} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
	)
	add_dependencies(cri_${api_version} grpc)
endfunction()

if(NOT EMSCRIPTEN)
	add_dependencies(sinsp tbb)
endif()

if(NOT WIN32)
	if(NOT MINIMAL_BUILD)
		if(NOT EMSCRIPTEN)
			add_dependencies(sinsp openssl curl)
		endif()
	endif()

	if(NOT APPLE)
		if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
			include(protobuf)
			include(cares)
			prepare_cri_grpc(v1alpha2)
			prepare_cri_grpc(v1)

			target_link_libraries(
				sinsp
				PRIVATE cri_v1alpha2 cri_v1
				INTERFACE "${GRPC_LIBRARIES}" "${GRPCPP_LIB}" "${GRPC_LIB}" "${GPR_LIB}"
						  "${PROTOBUF_LIB}" "${CARES_LIB}"
			)
			list(
				APPEND
				SINSP_PKGCONFIG_LIBRARIES
				"${GRPC_LIBRARIES}"
				"${GRPCPP_LIB}"
				"${GRPC_LIB}"
				"${GPR_LIB}"
				"${PROTOBUF_LIB}"
				"${CARES_LIB}"
			)

			if(NOT MUSL_OPTIMIZED_BUILD)
				find_library(LIB_ANL anl)
				if(LIB_ANL)
					target_link_libraries(sinsp INTERFACE rt anl)
					list(APPEND SINSP_PKGCONFIG_LIBRARIES rt anl)
				else()
					target_link_libraries(sinsp INTERFACE rt)
					list(APPEND SINSP_PKGCONFIG_LIBRARIES rt)
				endif()
			endif()

		else()
			target_link_libraries(sinsp INTERFACE rt)
			list(APPEND SINSP_PKGCONFIG_LIBRARIES rt)
		endif() # NOT MINIMAL_BUILD
	endif() # NOT APPLE

	target_link_libraries(sinsp INTERFACE "${OPENSSL_LIBRARIES}")
	list(APPEND SINSP_PKGCONFIG_LIBRARIES "${OPENSSL_LIBRARIES}")

	target_link_libraries(sinsp INTERFACE dl pthread)
	list(APPEND SINSP_PKGCONFIG_LIBRARIES dl pthread)

	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
			target_link_libraries(sinsp INTERFACE stdc++fs)
			list(APPEND SINSP_PKGCONFIG_LIBRARIES stdc++fs)
		endif()
	endif()
endif() # NOT WIN32

if(APPLE)
	target_link_libraries(sinsp PRIVATE "-framework CoreFoundation")
	target_link_libraries(sinsp PRIVATE "-framework SystemConfiguration")
	set_target_properties(sinsp PROPERTIES LINK_FLAGS "-Wl,-F/Library/Frameworks")
endif()

option(CREATE_TEST_TARGETS "Enable make-targets for unit testing" ON)

if(CREATE_TEST_TARGETS)
	# Add unit test directories
	add_subdirectory(test)
endif()

option(BUILD_LIBSINSP_EXAMPLES "Build libsinsp examples" ON)
if(BUILD_LIBSINSP_EXAMPLES)
	add_subdirectory(examples)
	add_subdirectory(sinsp_debug)
endif()

if(NOT DEFINED SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR)
	set(SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR "AGENT_CGROUP_MEM_PATH")
endif()
add_definitions(-DSINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR="${SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR}")

# Build our pkg-config "Libs:" flags. For now, loop over SINSP_PKGCONFIG_LIBRARIES. If we ever start
# using pkg_search_module or pkg_check_modules in cmake/modules we could add each module to our
# "Requires:" line instead. We might need to expand this to use some of the techniques in
# https://github.com/curl/curl/blob/curl-7_84_0/CMakeLists.txt#L1539
set(SINSP_PKG_CONFIG_LIBS)
set(SINSP_PKG_CONFIG_LIBDIRS "")
foreach(sinsp_lib ${SINSP_PKGCONFIG_LIBRARIES})
	if(${sinsp_lib} MATCHES "^-")
		# We have a flag. Pass it through unchanged.
		list(APPEND SINSP_PKG_CONFIG_LIBS ${sinsp_lib})
	elseif(${sinsp_lib} MATCHES "/")
		# We have a path. Convert it to -L<dir> + -l<lib>.
		get_filename_component(sinsp_lib_dir ${sinsp_lib} DIRECTORY)
		list(APPEND SINSP_PKG_CONFIG_LIBDIRS -L${sinsp_lib_dir})
		get_filename_component(sinsp_lib_base ${sinsp_lib} NAME_WE)
		string(REGEX REPLACE "^lib" "" sinsp_lib_base ${sinsp_lib_base})
		list(APPEND SINSP_PKG_CONFIG_LIBS -l${sinsp_lib_base})
	elseif(${sinsp_lib} STREQUAL "scap")
		# We require libscap.pc, so skip it.
	else()
		# Assume we have a plain library name. Prefix it with "-l".
		list(APPEND SINSP_PKG_CONFIG_LIBS -l${sinsp_lib})
	endif()
endforeach()

# Build our pkg-config "Cflags:" flags.
set(SINSP_PKG_CONFIG_INCLUDES "")
foreach(sinsp_include_directory ${LIBSINSP_INCLUDE_DIRS})
	list(APPEND SINSP_PKG_CONFIG_INCLUDES -I${sinsp_include_directory})
endforeach()

string(REPLACE ";" " " SINSP_PKG_CONFIG_LIBS "${SINSP_PKG_CONFIG_LIBS}")
list(REMOVE_DUPLICATES SINSP_PKG_CONFIG_LIBDIRS)
string(REPLACE ";" " " SINSP_PKG_CONFIG_LIBDIRS "${SINSP_PKG_CONFIG_LIBDIRS}")
list(REMOVE_DUPLICATES SINSP_PKG_CONFIG_INCLUDES)
string(REPLACE ";" " " SINSP_PKG_CONFIG_INCLUDES "${SINSP_PKG_CONFIG_INCLUDES}")
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/libsinsp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libsinsp.pc @ONLY
)

=== userspace/libsinsp/test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#

include(jsoncpp)
if(NOT EMSCRIPTEN)
	include(tbb)
endif()
if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
	include(curl)
endif() # MINIMAL_BUILD

include(zlib)

if(WIN32)
	set(CMAKE_CXX_FLAGS
		"-D_CRT_SECURE_NO_WARNINGS -DWIN32 -DMINIMAL_BUILD /EHsc /W3 /Zi /std:c++17"
	)
	set(CMAKE_CXX_FLAGS_DEBUG ${FALCOSECURITY_LIBS_DEBUG_FLAGS})
	set(CMAKE_CXX_STANDARD 17)
endif()

# Create a libsinsp_test_var.h file with some variables used by our tests
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/libsinsp_test_var.h.in"
	"${CMAKE_CURRENT_BINARY_DIR}/libsinsp_test_var.h"
)

file(GLOB_RECURSE TEST_PLUGINS ${CMAKE_CURRENT_SOURCE_DIR}/plugins/*.cpp)

if(NOT WIN32)
	file(GLOB_RECURSE SINSP_PARSERS_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/parsers/*.cpp)

	file(GLOB_RECURSE SINSP_CLASSES_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/classes/*.cpp)

	file(GLOB_RECURSE SINSP_FILTERCHECKS_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/filterchecks/*.cpp)

	file(GLOB_RECURSE SINSP_CONTAINER_ENGINE_SUITE
		 ${CMAKE_CURRENT_SOURCE_DIR}/container_engine/*.cpp
	)
endif()

option(SCAP_FILES_SUITE_ENABLE "Enable scap-file tests in sinsp" "ON")
# Scap-files on Big Endian systems are not supported
if((NOT ${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "s390x") AND ${SCAP_FILES_SUITE_ENABLE})
	# Binary dir in which we will save all our Cmake files
	file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/scap_files")
	# Add here the name for new scap-files
	set(SCAP_FILE_NAMES "kexec_arm64.scap" "kexec_x86.scap" "sample.scap")
	set(SCAP_FILE_DOWNLOAD_PREFIX "https://download.falco.org/fixtures/libs/scap_files")
	message(STATUS "Download all scap-files from: ${SCAP_FILE_DOWNLOAD_PREFIX}")
	foreach(FILE_NAME ${SCAP_FILE_NAMES})
		message(STATUS "Downloading scap-file: ${SCAP_FILE_DOWNLOAD_PREFIX}/${FILE_NAME}")
		if(NOT EXISTS "${CMAKE_BINARY_DIR}/scap_files/${FILE_NAME}")
			file(DOWNLOAD "${SCAP_FILE_DOWNLOAD_PREFIX}/${FILE_NAME}"
				 "${CMAKE_BINARY_DIR}/scap_files/${FILE_NAME}" SHOW_PROGRESS
			)
		else()
			message(STATUS "Skipping download, file already present")
		endif()
	endforeach()
	file(GLOB_RECURSE SCAP_FILES_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/scap_files/*.cpp)
endif()

file(GLOB_RECURSE TEST_HELPERS ${CMAKE_CURRENT_SOURCE_DIR}/helpers/*.cpp)

set(LIBSINSP_UNIT_TESTS_SOURCES
	ast_exprs.ut.cpp
	test_utils.cpp
	sinsp_with_test_input.cpp
	cgroup_list_counter.ut.cpp
	events_evt.ut.cpp
	events_file.ut.cpp
	events_fspath.ut.cpp
	events_injection.ut.cpp
	events_net.ut.cpp
	events_param.ut.cpp
	events_plugin.ut.cpp
	events_proc.ut.cpp
	events_user.ut.cpp
	external_processor.ut.cpp
	gvisor_config.ut.cpp
	mpsc_priority_queue.ut.cpp
	token_bucket.ut.cpp
	ppm_api_version.ut.cpp
	plugins.ut.cpp
	plugin_manager.ut.cpp
	prefix_search.ut.cpp
	string_visitor.ut.cpp
	filtercheck_has_args.ut.cpp
	filter_escaping.ut.cpp
	filter_parser.ut.cpp
	filter_op_bcontains.ut.cpp
	filter_op_contains.ut.cpp
	filter_op_pmatch.ut.cpp
	filter_op_net_compare.ut.cpp
	filter_op_numeric_compare.ut.cpp
	filter_compiler.ut.cpp
	filter_transformer.ut.cpp
	user.ut.cpp
	sinsp_utils.ut.cpp
	state.ut.cpp
	dns_manager.ut.cpp
	eventformatter.ut.cpp
	sinsp_metrics.ut.cpp
	thread_table.ut.cpp
	thread_pool.ut.cpp
	ifinfo.ut.cpp
	public_sinsp_API/event_related.cpp
	public_sinsp_API/sinsp_logger.cpp
	"${TEST_PLUGINS}"
	"${SINSP_PARSERS_SUITE}"
	"${SINSP_CLASSES_SUITE}"
	"${SINSP_FILTERCHECKS_SUITE}"
	"${SCAP_FILES_SUITE}"
	"${TEST_HELPERS}"
	"${SINSP_CONTAINER_ENGINE_SUITE}"
)

if(WIN32)
	list(
		REMOVE_ITEM
		LIBSINSP_UNIT_TESTS_SOURCES
		events_file.ut.cpp
		events_fspath.ut.cpp
		events_net.ut.cpp
		events_proc.ut.cpp
		events_user.ut.cpp
		filter_op_net_compare.ut.cpp
		user.ut.cpp
		thread_table.ut.cpp
		public_sinsp_API/sinsp_logger.cpp
	)
elseif(APPLE OR EMSCRIPTEN)
	list(REMOVE_ITEM LIBSINSP_UNIT_TESTS_SOURCES events_net.ut.cpp filter_op_net_compare.ut.cpp
		 ${CMAKE_CURRENT_SOURCE_DIR}/parsers/parse_connect.cpp
	)
endif()

if(NOT MINIMAL_BUILD)
	list(APPEND LIBSINSP_UNIT_TESTS_SOURCES procfs_utils.ut.cpp)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	list(
		APPEND
		LIBSINSP_UNIT_TESTS_SOURCES
		async_key_value_source.ut.cpp
		filter_ppm_codes.ut.cpp
		public_sinsp_API/events_set.cpp
		public_sinsp_API/interesting_syscalls.cpp
		public_sinsp_API/ppm_sc_codes.cpp
	)
endif()

# Link against additional files could be useful when testing plugins `ADDITIONAL_SINSP_TESTS_SUITE`
# is a list of source files `;` separated
if(ADDITIONAL_SINSP_TESTS_SUITE)
	message(STATUS "- Additional sinsp source files: ${ADDITIONAL_SINSP_TESTS_SUITE}")
	list(APPEND LIBSINSP_UNIT_TESTS_SOURCES "${ADDITIONAL_SINSP_TESTS_SUITE}")
endif()

add_executable(unit-test-libsinsp ${LIBSINSP_UNIT_TESTS_SOURCES})

if(EMSCRIPTEN)
	target_compile_options(unit-test-libsinsp PRIVATE "-sDISABLE_EXCEPTION_CATCHING=0")
	target_link_options(unit-test-libsinsp PRIVATE "-sDISABLE_EXCEPTION_CATCHING=0")
	target_link_options(unit-test-libsinsp PRIVATE "-sALLOW_MEMORY_GROWTH=1")
	target_link_options(
		unit-test-libsinsp PRIVATE "-sEXPORTED_FUNCTIONS=['_main','_htons','_ntohs']"
	)
	# note(jasondellaluce): since we run tests with node, we need to add this for reading from local
	# capture files.
	target_link_options(unit-test-libsinsp PRIVATE "-sNODERAWFS=1")
endif()

target_include_directories(
	unit-test-libsinsp
	PRIVATE ${LIBS_DIR} # needed for driver/event_stats.h
			${CMAKE_CURRENT_BINARY_DIR} # needed for libsinsp_test_var.h.in
			${CMAKE_CURRENT_SOURCE_DIR}
)

target_link_libraries(
	unit-test-libsinsp sinsp "${GTEST_LIB}" "${GTEST_MAIN_LIB}" "${TBB_LIB}" "${JSONCPP_LIB}"
)

# Add some additional include directories associated with `ADDITIONAL_SINSP_TESTS_SUITE`
# `ADDITIONAL_SINSP_TESTS_INCLUDE_FOLDERS` is a list of include paths `;` separated
if(ADDITIONAL_SINSP_TESTS_INCLUDE_FOLDERS)
	message(STATUS "- Additional include directories: ${ADDITIONAL_SINSP_TESTS_INCLUDE_FOLDERS}")
	target_include_directories(unit-test-libsinsp PRIVATE ${ADDITIONAL_SINSP_TESTS_INCLUDE_FOLDERS})
endif()

add_custom_target(
	run-unit-test-libsinsp
	DEPENDS unit-test-libsinsp
	COMMAND unit-test-libsinsp
)

=== userspace/libscap/engine/bpf/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#
add_library(scap_engine_bpf scap_bpf.c attached_prog.c)
add_dependencies(scap_engine_bpf libelf zlib)
target_link_libraries(
	scap_engine_bpf PRIVATE scap_event_schema scap_platform scap_engine_util scap_error
							${LIBELF_LIB} ${ZLIB_LIB}
)
target_include_directories(scap_engine_bpf PRIVATE ${LIBELF_INCLUDE})

set_scap_target_properties(scap_engine_bpf)

=== userspace/libscap/engine/gvisor/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#
include(protobuf)
include(jsoncpp)

find_package(Threads)

set(scap_engine_gvisor_sources
	${CMAKE_CURRENT_SOURCE_DIR}/parsers.cpp ${CMAKE_CURRENT_SOURCE_DIR}/fillers.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gvisor.cpp ${CMAKE_CURRENT_SOURCE_DIR}/scap_gvisor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/scap_gvisor_platform.cpp ${CMAKE_CURRENT_SOURCE_DIR}/runsc.cpp
)

set(scap_engine_gvisor_generated_sources
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/common.pb.cc
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/container.pb.cc
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/sentry.pb.cc
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/syscall.pb.cc
)

set(scap_engine_gvisor_generated_headers
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/common.pb.h
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/container.pb.h
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/sentry.pb.h
	${CMAKE_CURRENT_BINARY_DIR}/pkg/sentry/seccheck/points/syscall.pb.h
)

add_custom_command(
	OUTPUT ${scap_engine_gvisor_generated_sources} ${scap_engine_gvisor_generated_headers}
	COMMENT "Generate gVisor protobuf definitions"
	DEPENDS protobuf
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/common.proto
	COMMAND ${PROTOC} -I ${CMAKE_CURRENT_SOURCE_DIR}/proto --cpp_out=.
			${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/common.proto
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/container.proto
	COMMAND ${PROTOC} -I ${CMAKE_CURRENT_SOURCE_DIR}/proto --cpp_out=.
			${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/container.proto
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/sentry.proto
	COMMAND ${PROTOC} -I ${CMAKE_CURRENT_SOURCE_DIR}/proto --cpp_out=.
			${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/sentry.proto
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/syscall.proto
	COMMAND ${PROTOC} -I ${CMAKE_CURRENT_SOURCE_DIR}/proto --cpp_out=.
			${CMAKE_CURRENT_SOURCE_DIR}/proto/pkg/sentry/seccheck/points/syscall.proto
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

if(USE_BUNDLED_JSONCPP)
	add_dependencies(scap jsoncpp)
endif()

if(BUILD_SHARED_LIBS)
	# Trying to build a shared scap_engine_gvisor will result in circular dependencies, so just add
	# our sources to scap. Additionally, the GENERATED property doesn't propogate across
	# directories, so enforce our dependency chain using an object library.
	# https://gitlab.kitware.com/cmake/cmake/-/issues/18399
	add_library(
		scap_engine_gvisor_o OBJECT ${scap_engine_gvisor_sources}
									${scap_engine_gvisor_generated_sources}
	)
	set_property(TARGET scap_engine_gvisor_o PROPERTY POSITION_INDEPENDENT_CODE ON)

	add_dependencies(scap_engine_gvisor_o uthash)
	add_dependencies(scap scap_engine_gvisor_o)
	target_sources(scap PRIVATE $<TARGET_OBJECTS:scap_engine_gvisor_o>)
else()
	add_library(
		scap_engine_gvisor ${scap_engine_gvisor_sources} ${scap_engine_gvisor_generated_sources}
	)

	add_dependencies(scap_engine_gvisor uthash)
	target_link_libraries(
		scap_engine_gvisor PRIVATE scap scap_platform_util scap_error ${CMAKE_THREAD_LIBS_INIT}
								   ${PROTOBUF_LIB} ${JSONCPP_LIB}
	)

	target_include_directories(scap_engine_gvisor PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

	set_scap_target_properties(scap_engine_gvisor)
endif()

=== userspace/libscap/engine/nodriver/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#
add_library(scap_engine_nodriver nodriver.c)
target_link_libraries(scap_engine_nodriver PRIVATE scap_engine_noop)
set_scap_target_properties(scap_engine_nodriver)

=== userspace/libscap/engine/savefile/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
#
# Since we have circular dependencies between libscap and the savefile engine, make this library
# always static (directly linked into libscap)
add_library(scap_engine_savefile STATIC scap_savefile.c scap_reader_gzfile.c scap_reader_buffered.c)

add_dependencies(scap_engine_savefile zlib)
target_link_libraries(scap_engine_savefile PRIVATE scap_engine_noop scap_platform_util ${ZLIB_LIB})

=== debian/changelog ===
falcosecurity-libs (0.18.1-2ubuntu4) plucky; urgency=medium

  * No-change rebuild for libjsoncpp26

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Nov 2024 10:47:27 +0000

falcosecurity-libs (0.18.1-2ubuntu3) plucky; urgency=medium

  * Back in sync w Debian

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:32:22 +0100

falcosecurity-libs (0.18.1-2ubuntu2) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:31:31 +0100

falcosecurity-libs (0.18.1-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 21:56:34 +0100

falcosecurity-libs (0.18.1-2) unstable; urgency=medium

  * Disabling i386 builds
    This has been broken upstream for a long time

 -- Dima Kogan <dkogan@debian.org>  Tue, 08 Oct 2024 21:45:03 -0700

falcosecurity-libs (0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Tue, 01 Oct 2024 21:51:40 -0700

falcosecurity-libs (0.15.1-4ubuntu2) oracular; urgency=medium

  * debian/patches/fix-driver-fix-build-of-kmod-on-linux-6.10.patch
    - Linux 6.10: fix build of kmod (LP: #2071301)

 -- Guoqing Jiang <guoqing.jiang@canonical.com>  Mon, 29 Jul 2024 10:17:05 +0800

falcosecurity-libs (0.15.1-4ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 May 2024 08:07:10 +0200

falcosecurity-libs (0.15.1-4) unstable; urgency=medium

  * Reverted the use-group-to-access-scap-device patches.
    Because they didn't work properly. (Reopens: #745706)
    (Closes: #1071622)

 -- Dima Kogan <dkogan@debian.org>  Fri, 24 May 2024 21:32:53 -0700

falcosecurity-libs (0.15.1-3ubuntu3) oracular; urgency=medium

  * Rebuild against new libre2-11.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 May 2024 19:35:10 +0200

falcosecurity-libs (0.15.1-3ubuntu2) oracular; urgency=medium

  * Rebuild against new libre11.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 24 May 2024 10:39:05 +0200

falcosecurity-libs (0.15.1-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 May 2024 11:35:10 +0200

falcosecurity-libs (0.15.1-3) unstable; urgency=medium

  * scap driver now accessible as a non-root user, if they're in the
    "scap" group.
    Thanks to Gerald Combs <gerald@wireshark.org> (Closes: #745706)
  * debian/watch doesn't consider pre-release tags

 -- Dima Kogan <dkogan@debian.org>  Fri, 17 May 2024 22:41:31 -0700

=== debian/control ===
Source: falcosecurity-libs
Section: libdevel
Priority: optional
Maintainer: Dima Kogan <dkogan@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
               cmake,
               debhelper-compat (= 13),
               libvalijson-dev (>= 0.6),
               libb64-dev,
               libc-ares-dev,
               libcurl4-openssl-dev,
               libgrpc++-dev,
               libgrpc-dev,
               libgtest-dev,
               libjq-dev,
               libjsoncpp-dev,
               libprotobuf-dev,
               libssl-dev,
               libtbb-dev,
               zlib1g-dev,
               libjsoncpp-dev,
               protobuf-compiler,
               protobuf-compiler-grpc,
               libprotobuf-dev,
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el s390x] | liblua5.1-0-dev,
               libelf-dev,
               libre2-dev,
               libcap-dev,
               uthash-dev,
               libabsl-dev
Build-Depends-Indep: dh-sequence-dkms
Testsuite: autopkgtest-pkg-dkms
Standards-Version: 4.6.0
Homepage: https://github.com/falcosecurity/libs
Vcs-Git: https://salsa.debian.org/debian/falcosecurity-libs.git
Vcs-Browser: https://salsa.debian.org/debian/falcosecurity-libs

Package: libfalcosecurity0t64
Provides: ${t64:Provides}
Replaces: libfalcosecurity0
Breaks: libfalcosecurity0 (<< ${source:Version})
Section: libs
# Disabling i386 builds for now; broken upstream. See: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1067619
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the run-time libraries to read the events from the
 driver.

Package: libfalcosecurity0-dev
Section: libdevel
# Disabling i386 builds for now; broken upstream. See: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1067619
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${misc:Depends}, libfalcosecurity0t64 (= ${binary:Version})
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the build-time libraries to read the events from the
 driver.

Package: falcosecurity-scap-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Recommends: sysdig
Description: Kernel driver for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the sources for the kernel driver used by Falco and
 Sysdig to collect data
